$regfile = "m8def.dat"
$crystal = 8000000
Config Portc.5 = Output                                     'nadajnik
Config Portb.0 = Output                                     'buzzerek
Config Portd.5 = Output                                     'zielone diody
Config Portd.6 = Output                                     'te diody
Config Portd.7 = Output                                     'czerwone diody

Config Portb.1 = Output                                     'nieuywane piny
Config Portb.2 = Output
Config Portc.4 = Output
Config Portd.0 = Output
Config Portd.1 = Output
Config Portd.2 = Output
Config Portd.3 = Output
Config Portd.4 = Output


Reset Portc.4                                               'wyczenie tranzystorw wyjciowych
Reset Portb.0
Reset Portd.5
Reset Portd.6
Reset Portd.7

Set Portb.1                                                 'podcignicie nieuywanych wyprowadze
Set Portb.2                                                 'do stanu wysokiego
Set Portc.4
Set Portd.0
Set Portd.1
Set Portd.2
Set Portd.3
Set Portd.4

Config Adc = Single , Prescaler = Auto , Reference = Avcc   'LM78L05 jako r. nap. odniesienia dla ADC
Start Adc                                                   'uruchomienie ADC

Dim Alert As Integer                                        'napicie na P3
Dim Yel As Integer                                          'napicie na P2
Dim Gre As Integer                                          'napicie na P1
Dim U As Integer                                            'napicie z przetwornika
Dim Usred As Integer                                        'uredniona warto napicia z przetwornika
Dim I As Word                                               'do emitowania ultradwikw
Dim Usrednianie As Byte                                     'do wykonania redniej arytmetycznej z dwch pomiarw
Dim Il_petli As Byte                                        'ilo wykonanych ptli do czasu upienia
Dim Aktywny As Bit                                          'flagi w postaci zmiennych bitowych
Dim Odliczanie As Bit
Dim Ugorne As Integer                                       'zmienne pomocnicze
Dim Udolne As Integer
Dim Upoprz As Integer

Il_petli = 0                                                'zerowanie zmiennych i flag
Upoprz = 0
Reset Aktywny
Reset Odliczanie

'-------------------------------------------------------------

Do                                                          'pocztek nieskoczonej ptli

Alert = Getadc(2)                                           'odczytanie napi z potencjometrw
Yel = Getadc(1)
Gre = Getadc(0)

Usrednianie = 0                                             'wyzerowanie zmiennych
Usred = 0

'-------------------------------------------------------------

While Usrednianie < 2                                       'wykonanie dwch cykli pomiarw odlegoci

I = 1
While I < 15000                                             'emitowanie fali 40kHz z wypenieniem 50%
Incr I
Set Portc.5
Waitus 10
Reset Portc.5
Waitus 10
Wend

U = Getadc(3)                                               'odczyt napicia z odbiornika
Usred = Usred + U                                           'dodanie do siebie wynikw kolejnych pomiarw
Incr Usrednianie
Wend

Usred = Usred / 2                                           'podzielenie przez ilo pomiarw

'-------------------------------------------------------------

If Aktywny = 1 Then                                         'jeeli ustawiona jest flaga aktywnoci urzdzenia

If Odliczanie = 1 Then                                      'jeeli odczyty zmieniaja si w maych granicach
Incr Il_petli                                               'zacznij odliczanie do upienia
End If                                                      'poprzez zliczanie kolejno wykonanych ptli programu

If Usred <= Gre Then                                        'jeeli odczytane napicie jest nisze ni
Set Portd.5                                                 'ustawione na P1 - wcz diody zielone

Set Portb.0                                                 'i piknij raz buzzerkiem
Waitms 10
Reset Portb.0

Else                                                        'w przeciwnym razie
Reset Portd.5                                               'zga diody zielone
End If

'-------------------------

If Usred <= Yel And Usred > Gre Then                        'jeeli odczytane napicie jest w przedziale
Set Portd.6                                                 'midzy napiciami na P1 i P2 - wcz diody te

Set Portb.0                                                 'i piknij dwa razy, mocniej
Waitms 15
Reset Portb.0

Waitms 50

Set Portb.0
Waitms 15
Reset Portb.0

Else                                                        'w przeciwnym razie
Reset Portd.6                                               'zga diody te
End If

'-------------------------

If Usred > Yel Then                                         'jeeli odczytane napicie jest wysze ni
Set Portd.7                                                 'ustawione na P2 - wcz diody czerwone

If Usred <= Alert Then                                      'jeeli odczytane napicie jest mniejsze ni na P3
Set Portb.0                                                 'pinij 3 razy, jeszcze mocniej
Waitms 20
Reset Portb.0

Waitms 50

Set Portb.0
Waitms 20
Reset Portb.0

Waitms 50

Set Portb.0
Waitms 20
Reset Portb.0
Else                                                        'jeeli za napicie jest wiksze ni na P3
Set Portb.0                                                 'wcz buzzer na stae
End If                                                      'i utrzymaj czerwone diody zaczone

Else                                                        'w przeciwnym razie
Reset Portd.7                                               'wycz buzzer i czerwone diody
Reset Portb.0
End If

End If

'-------------------------------------------------------------

'sprawdzenie, czy odczytywane z SG1 napicie, waha si dostatecznie mocno
'jeeli nie, upij ukad po 20 cyklach
Ugorne = Usred + 80                                         'obliczenie grnej i dolnej granicy
Udolne = Usred - 80                                         'napicia odczytywanego
If Upoprz < Udolne Or Upoprz > Ugorne Then                  'jeeli wykracza poza nie

Set Aktywny                                                 'uaktywnij ukad, bo wykryty zosta ruch
Upoprz = Usred                                              'zaaduj aktualn warto do porwnywania
Reset Odliczanie                                            'wycz flag odliczania do upienia
Il_petli = 0                                                'wyzeruj ilo ptli

End If                                                      'w przeciwnym razie - jeeli napicie oscyluje w niewielkich granicach

If Upoprz >= Udolne And Upoprz <= Ugorne Then
Set Odliczanie                                              'rozpocznij odliczanie do upienia

If Il_petli < 20 Then                                       'jeeli nie naliczono 20 ptli
Set Aktywny                                                 'pozostaw ukad w stanie pracy
Else                                                        'w przeciwnym razie
Reset Aktywny                                               'upij go, jeeli po 20 cyklach nic si nie dzieje
End If

End If

'-------------------------------------------------------------

'przygotowanie do upienia: jeeli aktywna jest flaga odliczania (tj. napicie fluktuuje nieznacznie)
'i naliczonych zostao nie mniej ni 20 cykli pracy
If Il_petli >= 20 And Odliczanie = 1 Then
Reset Odliczanie                                            'wycz flag odliczania
Reset Aktywny                                               'wycz flag aktywnoci, ktra aktywuje diody
Reset Portb.0                                               'wycz buzzerek
Reset Portd.5                                               'oraz diody
Reset Portd.6
Reset Portd.7
End If

'-------------------------------------------------------------



Loop
End